/// class PD.Manage.Modules.RecycleBin

PD.Manage.Modules.RecycleBin =
PD.Manage.Module.extend({

    //===================================
    // FIELDS
    //===================================

    _grid: null,
    _toolbar: null,

    //===================================
    // EVENT HANDLERS
    //===================================

    onActivate: function (e) {

        var that = this,
            clearSelectionsAndRefreshGridFn = function (e) {
                that._grid.refresh({
                    clear: true
                });
            };

        this.subscriptions.add("recycle-bin/delete", clearSelectionsAndRefreshGridFn);
        this.subscriptions.add("recycle-bin/empty", clearSelectionsAndRefreshGridFn);
        this.subscriptions.add("recycle-bin/restore", clearSelectionsAndRefreshGridFn);

        this._grid_init();
        this._toolbar_init();

    },

    prepare: function () {

        var that = this;

        PD.ajax({
            url: PD.Path.resolve("~/Manage/RecycleBin"),
            success: function (data) {
                that.data("viewStateId", data.viewStateId);
                that.ready();
            },
            error: function (e) {
                that.error();
                e.errorHandled = true;
            }
        });

    },

    //===================================
    // PROTECTED METHODS
    //===================================

    template: function (e) {
        return [
            "<div style='position:absolute;top:0;left:0;bottom:0;right:0;overflow:hidden;'>",
                "<div data-id='toolbar' style='position:absolute;height:30px;top:10px;left:10px;right:10px;'>",
                "</div>",
                "<div data-id='grid' style='position:absolute;top:50px;left:10px;bottom:10px;right:10px;border:1px solid #DDDDDD;'>",
                "</div>",
            "</div>"
        ];
    },

    focus: function () {
        this._super();
        this._grid.redraw();
    },

    //===================================
    // PRIVATE METHODS
    //===================================

    _grid_init: function () {

        var that = this;

        this._grid = new PD.Web.UI.Controls.ViewGrid({
            insertAt: "[data-id=grid]",
            viewStateId: this.data("viewStateId"),
            selectOnRightClick: true,
            change: function (e) {

                PD.context.get_default().get_commands().setState({
                    "pd/recycle-bin": {
                        recycleBinItems: e.selections.toArray()
                    }
                });

            },
            contextMenu: {
                type: "PD.Manage.Modules.RecycleBinContextMenu",
                context: function () {
                    return {
                        viewGrid: that._grid,
                        item: that._grid.getSelection()
                    };
                }
            }
        });

        this.get_children().add(this._grid);

    },

    _toolbar_init: function () {

        var grid = this._grid;

        this._toolbar = new PD.Web.UI.Controls.Toolbar({
            insertAt: "[data-id=toolbar]",
            segments: [
                new PD.Manage.Modules.RecycleBinToolbarSegment()
            ]
        });

        this.get_children().add(this._toolbar);

    }

});